// Code generated by goa v3.8.5, DO NOT EDIT.
//
// signer HTTP client types
//
// Command:
// $ goa gen
// gitlab.com/gaia-x/data-infrastructure-federation-services/tsa/signer/design

package client

import (
	signer "gitlab.com/gaia-x/data-infrastructure-federation-services/tsa/signer/gen/signer"
	goa "goa.design/goa/v3/pkg"
)

// CredentialProofRequestBody is the type of the "signer" service
// "CredentialProof" endpoint HTTP request body.
type CredentialProofRequestBody struct {
	// Key namespace.
	Namespace string `form:"namespace" json:"namespace" xml:"namespace"`
	// Key to use for the proof signature (optional).
	Key string `form:"key" json:"key" xml:"key"`
	// Verifiable Credential in JSON format.
	Credential interface{} `form:"credential" json:"credential" xml:"credential"`
}

// PresentationProofRequestBody is the type of the "signer" service
// "PresentationProof" endpoint HTTP request body.
type PresentationProofRequestBody struct {
	// Issuer DID used to specify proof verification info.
	Issuer string `form:"issuer" json:"issuer" xml:"issuer"`
	// Key namespace.
	Namespace string `form:"namespace" json:"namespace" xml:"namespace"`
	// Key to use for the proof signature.
	Key string `form:"key" json:"key" xml:"key"`
	// Verifiable Presentation in JSON format.
	Presentation interface{} `form:"presentation" json:"presentation" xml:"presentation"`
}

// CreatePresentationRequestBody is the type of the "signer" service
// "CreatePresentation" endpoint HTTP request body.
type CreatePresentationRequestBody struct {
	// Issuer DID of the Verifiable Presentation.
	Issuer string `form:"issuer" json:"issuer" xml:"issuer"`
	// Key namespace.
	Namespace string `form:"namespace" json:"namespace" xml:"namespace"`
	// Key to use for the proof signature.
	Key string `form:"key" json:"key" xml:"key"`
	// Raw JSON to be included inside the VP as Verifiable Credential.
	Data []interface{} `form:"data" json:"data" xml:"data"`
	// Additional JSONLD contexts to be specified in the VP.
	Context []string `form:"context,omitempty" json:"context,omitempty" xml:"context,omitempty"`
}

// VerificationMethodResponseBody is the type of the "signer" service
// "VerificationMethod" endpoint HTTP response body.
type VerificationMethodResponseBody struct {
	// ID of verification method.
	ID *string `form:"id,omitempty" json:"id,omitempty" xml:"id,omitempty"`
	// Type of verification method key.
	Type *string `form:"type,omitempty" json:"type,omitempty" xml:"type,omitempty"`
	// Controller of verification method specified as DID.
	Controller *string `form:"controller,omitempty" json:"controller,omitempty" xml:"controller,omitempty"`
	// Public Key encoded in JWK format.
	PublicKeyJwk interface{} `form:"publicKeyJwk,omitempty" json:"publicKeyJwk,omitempty" xml:"publicKeyJwk,omitempty"`
}

// VerificationMethodsResponseBody is the type of the "signer" service
// "VerificationMethods" endpoint HTTP response body.
type VerificationMethodsResponseBody []*DIDVerificationMethodResponse

// VerifyCredentialResponseBody is the type of the "signer" service
// "VerifyCredential" endpoint HTTP response body.
type VerifyCredentialResponseBody struct {
	// Valid specifies if the proof is successfully verified.
	Valid *bool `form:"valid,omitempty" json:"valid,omitempty" xml:"valid,omitempty"`
}

// VerifyPresentationResponseBody is the type of the "signer" service
// "VerifyPresentation" endpoint HTTP response body.
type VerifyPresentationResponseBody struct {
	// Valid specifies if the proof is successfully verified.
	Valid *bool `form:"valid,omitempty" json:"valid,omitempty" xml:"valid,omitempty"`
}

// DIDVerificationMethodResponse is used to define fields on response body
// types.
type DIDVerificationMethodResponse struct {
	// ID of verification method.
	ID *string `form:"id,omitempty" json:"id,omitempty" xml:"id,omitempty"`
	// Type of verification method key.
	Type *string `form:"type,omitempty" json:"type,omitempty" xml:"type,omitempty"`
	// Controller of verification method specified as DID.
	Controller *string `form:"controller,omitempty" json:"controller,omitempty" xml:"controller,omitempty"`
	// Public Key encoded in JWK format.
	PublicKeyJwk interface{} `form:"publicKeyJwk,omitempty" json:"publicKeyJwk,omitempty" xml:"publicKeyJwk,omitempty"`
}

// NewCredentialProofRequestBody builds the HTTP request body from the payload
// of the "CredentialProof" endpoint of the "signer" service.
func NewCredentialProofRequestBody(p *signer.CredentialProofRequest) *CredentialProofRequestBody {
	body := &CredentialProofRequestBody{
		Namespace:  p.Namespace,
		Key:        p.Key,
		Credential: p.Credential,
	}
	return body
}

// NewPresentationProofRequestBody builds the HTTP request body from the
// payload of the "PresentationProof" endpoint of the "signer" service.
func NewPresentationProofRequestBody(p *signer.PresentationProofRequest) *PresentationProofRequestBody {
	body := &PresentationProofRequestBody{
		Issuer:       p.Issuer,
		Namespace:    p.Namespace,
		Key:          p.Key,
		Presentation: p.Presentation,
	}
	return body
}

// NewCreatePresentationRequestBody builds the HTTP request body from the
// payload of the "CreatePresentation" endpoint of the "signer" service.
func NewCreatePresentationRequestBody(p *signer.CreatePresentationRequest) *CreatePresentationRequestBody {
	body := &CreatePresentationRequestBody{
		Issuer:    p.Issuer,
		Namespace: p.Namespace,
		Key:       p.Key,
	}
	if p.Data != nil {
		body.Data = make([]interface{}, len(p.Data))
		for i, val := range p.Data {
			body.Data[i] = val
		}
	}
	if p.Context != nil {
		body.Context = make([]string, len(p.Context))
		for i, val := range p.Context {
			body.Context[i] = val
		}
	}
	return body
}

// NewVerificationMethodDIDVerificationMethodOK builds a "signer" service
// "VerificationMethod" endpoint result from a HTTP "OK" response.
func NewVerificationMethodDIDVerificationMethodOK(body *VerificationMethodResponseBody) *signer.DIDVerificationMethod {
	v := &signer.DIDVerificationMethod{
		ID:           *body.ID,
		Type:         *body.Type,
		Controller:   *body.Controller,
		PublicKeyJwk: body.PublicKeyJwk,
	}

	return v
}

// NewVerificationMethodsDIDVerificationMethodOK builds a "signer" service
// "VerificationMethods" endpoint result from a HTTP "OK" response.
func NewVerificationMethodsDIDVerificationMethodOK(body []*DIDVerificationMethodResponse) []*signer.DIDVerificationMethod {
	v := make([]*signer.DIDVerificationMethod, len(body))
	for i, val := range body {
		v[i] = unmarshalDIDVerificationMethodResponseToSignerDIDVerificationMethod(val)
	}

	return v
}

// NewVerifyCredentialVerifyResultOK builds a "signer" service
// "VerifyCredential" endpoint result from a HTTP "OK" response.
func NewVerifyCredentialVerifyResultOK(body *VerifyCredentialResponseBody) *signer.VerifyResult {
	v := &signer.VerifyResult{
		Valid: *body.Valid,
	}

	return v
}

// NewVerifyPresentationVerifyResultOK builds a "signer" service
// "VerifyPresentation" endpoint result from a HTTP "OK" response.
func NewVerifyPresentationVerifyResultOK(body *VerifyPresentationResponseBody) *signer.VerifyResult {
	v := &signer.VerifyResult{
		Valid: *body.Valid,
	}

	return v
}

// ValidateVerificationMethodResponseBody runs the validations defined on
// VerificationMethodResponseBody
func ValidateVerificationMethodResponseBody(body *VerificationMethodResponseBody) (err error) {
	if body.ID == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("id", "body"))
	}
	if body.Type == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("type", "body"))
	}
	if body.Controller == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("controller", "body"))
	}
	if body.PublicKeyJwk == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("publicKeyJwk", "body"))
	}
	return
}

// ValidateVerifyCredentialResponseBody runs the validations defined on
// VerifyCredentialResponseBody
func ValidateVerifyCredentialResponseBody(body *VerifyCredentialResponseBody) (err error) {
	if body.Valid == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("valid", "body"))
	}
	return
}

// ValidateVerifyPresentationResponseBody runs the validations defined on
// VerifyPresentationResponseBody
func ValidateVerifyPresentationResponseBody(body *VerifyPresentationResponseBody) (err error) {
	if body.Valid == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("valid", "body"))
	}
	return
}

// ValidateDIDVerificationMethodResponse runs the validations defined on
// DIDVerificationMethodResponse
func ValidateDIDVerificationMethodResponse(body *DIDVerificationMethodResponse) (err error) {
	if body.ID == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("id", "body"))
	}
	if body.Type == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("type", "body"))
	}
	if body.Controller == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("controller", "body"))
	}
	if body.PublicKeyJwk == nil {
		err = goa.MergeErrors(err, goa.MissingFieldError("publicKeyJwk", "body"))
	}
	return
}
